<script lang="ts" setup>
import { ref } from 'vue';
import Accordion from './../common/Accordion.vue';
import type { BaseLink } from '@/types/base';
import { CollaborationAlt4 } from 'slippers-ui/icons';

const icons = {
  CollaborationAlt4,
};

interface AccordionItem {
  header: string;
  content: string;
  button?: Array<BaseLink>;
}

interface AccordionWrapperProps {
  title: string;
  subtitle?: string;
  description?: string;
  accordion: Array<AccordionItem>;
  config: {
    icon?: string;
    isFullWidth: boolean;
  };
}

defineProps<AccordionWrapperProps>();

const isOpenIndex = ref(0);

const toggleController = (index: number) => {
  isOpenIndex.value = index;
};
</script>

<template>
  <section class="accordion-wrapper">
    <SlpContainer>
      <SlpRow>
        <SlpColumn :cols="config?.isFullWidth ? 12 : 6" class="slp-pr-32" size="lg">
          <div class="accordion-wrapper__icon-wrapper">
            <SlpIcon v-if="config.icon" :icon="icons[config.icon]" class="accordion-wrapper__icon" />
          </div>

          <SlpTypography tag="h2" variant="heading2-bold" class="slp-mb-16 slp-mt-8">{{ title }}</SlpTypography>
          <SlpTypography v-if="description" tag="p" variant="body1" class="description slp-mr-48 slp-mb-16">{{
            description
          }}</SlpTypography>
        </SlpColumn>
        <SlpColumn :cols="config?.isFullWidth ? 12 : 6" class="slp-pl-md-16 slp-mt-md-64" size="lg">
          <Accordion
            v-for="(item, index) in accordion"
            :key="item.header"
            :data="item"
            :is-open="isOpenIndex == index"
            @toggle-controller="toggleController(index)"
          />
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.accordion-wrapper {
  padding: $spacing-96 0;

  @media (max-width: $breakpoint-sm) {
    padding: $spacing-48 0;
    p {
      margin-bottom: $spacing-16;
    }
  }

  .description {
    margin-right: 48px;
    color: $color-text-200;

    @media (max-width: $breakpoint-md) {
      margin-right: 0px;
    }
  }

  &__icon-wrapper {
    background-color: $color-surface-900;
    border-radius: 50%;
    padding: $spacing-4;
    height: 48px;
    width: 48px;
    display: flex;
    align-items: center;
    justify-content: center;
    margin-bottom: $spacing-24;
  }

  &__icon {
    height: 28px;
    width: 28px;
  }

  .accordion {
    border-top: 1px solid $color-surface-300;

    :deep(.accordion__content-container) {
      padding: 12px $spacing-24 $spacing-24 0;
      .content {
        color: $color-text-200;
      }
    }
  }

  :deep(.accordion__summary) {
    padding: $spacing-16 0;
    font-weight: 660;
    font-size: 24px;
  }
}
</style>
